<template>
  <Error v-if="$fetchState.error" :error="$fetchState.error"></Error>
  <BaseBoard v-else pretitle="project" :skeleton="!dataLoaded">
    <template #title-board>
      <input
        class="form-control p-0 border-0 bg-transparent"
        data-cy="input-title-edit-project"
        data-intro="Start by editing your project name by clicking here"
        data-hint="Click on the title to edit it."
        data-hintposition="top-left"
        style="font-size: 20px"
        type="text"
        :value="project.title"
        @keyup="updateProjectTitle"
        @focusout="saveProject"
        @keyup.enter="saveProject"
      />
    </template>
    <template #header-right>
      <div class="justify-content-start">
        <div v-if="!dataLoaded">Loading project...</div>
        <ul v-else class="nav nav-tabs nav-tabs-project border-bottom-0">
          <li class="nav-item">
            <NuxtLink
              :to="tabLinks.board"
              class="nav-link nav-link-toggle-board"
              :class="{ active: isActive('board') }"
            >
              <DiceIcon class="mr-2" />
              Board
            </NuxtLink>
          </li>
          <li class="nav-item">
            <NuxtLink
              :to="tabLinks.outputs"
              class="nav-link nav-link-toggle-board"
              :class="{ active: isActive('outputs') }"
            >
              <LayoutListIcon class="mr-2" />
              Outputs
            </NuxtLink>
          </li>
          <li class="nav-item">
            <NuxtLink
              :to="tabLinks.config"
              class="nav-link nav-link-toggle-board"
              data-cy="configuration-tab"
              :class="{ active: isActive('config') }"
            >
              <AdjustmentsIcon class="mr-2" />
              Configuration
            </NuxtLink>
          </li>
          <li class="nav-toggle nav-item ml-auto">
            <div v-show="isActive('board')" class="btn-list">
              <div class="d-none d-sm-inline">
                <RimowSelectize
                  placeholder="Select a main scenario..."
                  item-icon="route"
                  :options="scenarios"
                  :selected="mainScenario"
                  :clearable="false"
                  :disabled="project.state.slug === 'running'"
                  @change="changeMainScenario"
                >
                  <template #button-append>
                    <NuxtLink
                      :to="`/projects/${id}/configure/${mainScenario?.id}`"
                      :class="{ 'disabled-action': mainScenario === undefined }"
                    >
                      <AdjustmentsIcon class="icon-xxs" />
                    </NuxtLink>
                  </template>
                </RimowSelectize>
              </div>
              <a
                class="btn btn-primary main-scenario-run d-none d-sm-inline-block"
                :class="{
                  disabled:
                    disableRunMainScenario || project.state.slug === 'running',
                }"
                @click="runScenario"
              >
                <PlayerPlayIcon v-if="project.state.slug !== 'running'" />
                <b-spinner
                  v-else
                  style="width: 1rem; height: 1rem; color: white"
                ></b-spinner>
                {{
                  project.state.slug === 'running'
                    ? 'Running...'
                    : 'Run main scenario'
                }}
              </a>
            </div>
            <div v-show="isActive('outputs')" class="btn-list">
              <div class="d-none d-sm-inline">
                <a class="btn disabled"> <EyeIcon />Show main output </a>
              </div>
              <a
                v-if="jobValid"
                data-cy="download-outputs-btn"
                class="btn btn-primary d-none d-sm-inline-block cursor-pointer"
                :href="downloadOutput"
                target="_blank"
              >
                <DownloadIcon />
                Download outputs
              </a>
            </div>
            <div v-show="isActive('config') && displayedJobs" class="btn-list">
              <div class="d-none d-sm-inline">
                <a
                  class="btn btn-primary d-none d-sm-inline-block cursor-pointer"
                  data-cy="reuse-config-btn"
                  @click="reuseConfig"
                >
                  <RefreshIcon />Reuse this config
                </a>
              </div>
            </div>
          </li>
        </ul>
      </div>
    </template>
    <template #content>
      <!-- for row in row  -->
      <div class="col">
        <NuxtChild />
      </div>
    </template>
  </BaseBoard>
</template>

<script>
import notificationsMixin from '~/mixins/notifications.js';
import helpersMixin from '~/mixins/helpers.js';
const tabs = {
  board: 'projects-id-view',
  outputs: 'projects-id-view-outputs',
  config: 'projects-id-view-config',
};

export default {
  mixins: [notificationsMixin, helpersMixin],
  layout: 'dashboard',
  middleware: 'auth',
  data() {
    return {
      id: this.$nuxt.$route.params.id,
    };
  },
  async fetch() {
    const id = this.$nuxt.$route.params.id;
    await this.$nuxt.context.store.dispatch('projects/fetchSingleProject', {
      id,
    });
    await this.$nuxt.context.store.dispatch('scenarios/fetchProjectScenarios', {
      projectId: id,
    });
    if (this.mainScenario) {
      await this.loadParametersMainScenario();
    }
  },
  head() {
    return {
      title: 'Projects - RISIS Workspace',
    };
  },
  computed: {
    tabLinks() {
      const id = this.$nuxt.$route.params.id;
      return {
        board: `/projects/${id}/view`,
        outputs: `/projects/${id}/view/outputs`,
        config: `/projects/${id}/view/config`,
      };
    },
    dataLoaded() {
      return !!this.rootData;
    },
    rootData() {
      return this.$store.getters['projects/fullSingleProject'](this.id);
    },
    project() {
      return this.rootData.project;
    },
    displayedJobs() {
      return (
        this.project.jobs.filter((job) => job.state?.slug === 'finished')
          .length > 0
      );
    },
    scenarios() {
      return this.rootData.scenarios;
    },
    dropdownScenarios() {
      const result = this.scenarios.map((sc) => {
        return {
          id: sc.id,
          title: sc.title,
          version: sc.version,
          description: sc.description,
          tags: sc.tags,
        };
      });
      return result;
    },
    mainScenario() {
      if (this.project.main_scenario) {
        return this.scenarios.find((sc) => {
          return sc.id === this.project.main_scenario.id;
        });
      }
      return undefined;
    },
    jobId() {
      return this.$nuxt.context.store.getters['ui/activeJob'].id;
    },
    jobValid() {
      const job = this.project.jobs.find((job) => job.id === this.jobId);
      return job && job.response && job.response.error === undefined;
    },
    downloadOutput() {
      if (this.jobValid) {
        const token = this.$auth.strategy.token.get().split(' ');
        return `${this.$config.apiRoot}/projects/${this.id}/jobs/${this.jobId}/outputs?access_token=${token[1]}`;
      }
      return '#';
    },
    disableRunMainScenario() {
      if (this.mainScenario) {
        return this.$store.getters['scenarios/hasError'](this.mainScenario.id);
      }
      return true;
    },
    activeJob() {
      return this.$nuxt.context.store.state.ui.activeJob;
    },
  },
  methods: {
    isActive(tabKey) {
      return this.$nuxt.$route.name === tabs[tabKey];
    },
    async loadParametersMainScenario() {
      await this.$nuxt.context.store.dispatch('parameters/loadParameters', {
        projectId: this.id,
        scenarioId: this.mainScenario.id,
      });
    },
    async changeMainScenario(newMainScenario) {
      await this.$nuxt.context.store.dispatch('projects/setProjectProperty', {
        projectId: this.id,
        propertyName: 'main_scenario',
        value: { id: newMainScenario.id },
      });
      await this.$nuxt.context.store
        .dispatch('projects/saveProject', {
          id: this.id,
        })
        .catch(() => {
          this.showErrorNotification('Error updating project');
          return null;
        });
      await this.loadParametersMainScenario();
    },
    async runScenario() {
      if (
        !this.mainScenarioWithErrors &&
        this.project.state.slug !== 'running'
      ) {
        this.showNotification(
          `The scenario ${this.mainScenario.title} is running!`,
          'Running!'
        );
        await this.$nuxt.context.store.dispatch('scenarios/runScenario', {
          projectId: this.id,
          scenarioId: this.mainScenario.id,
        });
        await this.wait(100);
        await this.$nuxt.context.store.dispatch('projects/fetchSingleProject', {
          id: this.id,
        });
      }
    },
    async reuseConfig() {
      const response = await this.$nuxt.context.store.dispatch(
        'scenarios/reuseConfig',
        {
          jobId: this.activeJob.id,
        }
      );
      this.$router.push({
        path: `/projects/${this.id}/configure/${response.scenarioId}`,
      });
    },
    updateProjectTitle(event) {
      this.$nuxt.context.store.dispatch('projects/setProjectProperty', {
        projectId: this.id,
        propertyName: 'title',
        value: event.target.value,
      });
    },
    async saveProject() {
      if (this.project.changed?.length > 0) {
        if (this.project.title) {
          await this.$nuxt.context.store
            .dispatch('projects/saveProject', {
              id: this.id,
            })
            .then(() => {
              this.showNotification(
                'The title was updated successfully',
                'Project Updated!'
              );
              this.$nuxt.context.store.dispatch(
                'projects/unSetProjectProperty',
                {
                  projectId: this.id,
                  propertyName: 'title',
                }
              );
            })
            .catch(() => {
              this.showErrorNotification('Error updating the project title');
            });
        } else {
          this.showErrorNotification('Project title is required.');
        }
      }
    },
  },
};
</script>
